bootstrap 3.35 KB
Newer Older
1
#! /bin/sh
2

3 4 5 6 7 8 9 10 11 12
# bootstrap: the ultimate bootstrap/autogen.sh script for autotools projects
# Copyright (c) 2002, 2003, 2004, 2005, 2006 Sam Hocevar <sam@zoy.org>
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the Do What The Fuck You Want To
#    Public License, Version 2, as published by Sam Hocevar. See
#    http://sam.zoy.org/wtfpl/COPYING for more details.
#
# The latest version of this script can be found at the following place:
#   http://sam.zoy.org/autotools/
13

14
# Die if an error occurs
15
set -e
16

17 18 19 20 21 22 23 24 25 26 27 28 29 30 31
# Guess whether we are using configure.ac or configure.in
if test -f configure.ac; then
  conffile="configure.ac"
elif test -f configure.in; then
  conffile="configure.in"
else
  echo "$0: could not find configure.ac or configure.in"
  exit 1
fi

# Check for needed features
auxdir="`sed -ne 's/^[ \t]*A._CONFIG_AUX_DIR *( *\([^ )]*\).*/\1/p' $conffile`"
libtool="`grep -q '^[ \t]*A._PROG_LIBTOOL' $conffile && echo yes || echo no`"
header="`grep -q '^[ \t]*A._CONFIG_HEADER' $conffile && echo yes || echo no`"
aclocalflags="`sed -ne 's/^[ \t]*ACLOCAL_AMFLAGS[ \t]*=//p' Makefile.am`"
32

33
# Check for automake
34
amvers="no"
35
for v in "-1.10" "110" "-1.9" "19" "-1.8" "18" "-1.7" "17" "-1.6" "16" "-1.5" "15"; do
36 37 38 39 40 41 42
  if automake${v} --version >/dev/null 2>&1; then
    amvers="${v}"
    break
  fi
done

if test "${amvers}" = "no" && automake --version > /dev/null 2>&1; then
43 44 45
  amvers="`automake --version | sed -e '1s/[^0-9]*//' -e q`"
  if expr "$amvers" "<" "1.5" > /dev/null 2>&1; then
    amvers="no"
46
  else
47
    amvers=""
48
  fi
49 50
fi

51 52 53 54 55
if test "$amvers" = "no"; then
  echo "$0: you need automake version 1.5 or later"
  exit 1
fi

56 57 58 59 60 61 62 63
# Check for autoconf
acvers="no"
for v in "" "259" "253"; do
  if autoconf${v} --version >/dev/null 2>&1; then
    acvers="${v}"
    break
  fi
done
64

65 66
if test "$acvers" = "no"; then
  echo "$0: you need autoconf"
67 68 69
  exit 1
fi

70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89
# Check for libtool
if test "$libtool" = "yes"; then
  libtoolize="no"
  if glibtoolize --version >/dev/null 2>&1; then
    libtoolize="glibtoolize"
  else
    for v in "16" "15" "" "14"; do
      if libtoolize${v} --version >/dev/null 2>&1; then
        libtoolize="libtoolize${v}"
        break
      fi
    done
  fi

  if test "$libtoolize" = "no"; then
    echo "$0: you need libtool"
    exit 1
  fi
fi

90
# Remove old cruft
91
for x in aclocal.m4 configure config.guess config.log config.sub config.cache config.h.in config.h compile libtool.m4 ltoptions.m4 ltsugar.m4 ltversion.m4 ltmain.sh libtool ltconfig missing mkinstalldirs depcomp install-sh; do rm -f $x autotools/$x; if test -n "$auxdir"; then rm -f "$auxdir/$x"; fi; done
92
rm -Rf autom4te.cache
93 94 95 96 97 98
if test -n "$auxdir"; then
  if test ! -d "$auxdir"; then
    mkdir "$auxdir"
  fi
  aclocalflags="${aclocalflags} -I $auxdir"
fi
99

100 101 102 103 104 105 106 107 108 109
# Explain what we are doing from now
set -x

# Bootstrap package
if test "$libtool" = "yes"; then
  ${libtoolize} --copy --force
  if test -n "$auxdir" -a ! "$auxdir" = "." -a -f "ltmain.sh"; then
    echo "$0: working around a minor libtool issue"
    mv ltmain.sh "$auxdir/"
  fi
110
fi
111

112 113 114 115 116 117 118 119 120 121 122
aclocal${amvers} ${aclocalflags}
autoconf${acvers}
if test "$header" = "yes"; then
  autoheader${acvers}
fi
#add --include-deps if you want to bootstrap with any other compiler than gcc
#automake${amvers} --add-missing --copy --include-deps
automake${amvers} --foreign --add-missing --copy

# Remove cruft that we no longer want
rm -Rf autom4te.cache
123